"Status Line" by David Kinder

Include Flexible Windows by Jon Ingold.
Include Glulx Status Window Control by Erik Temple.

Testing Area is a room.

Understand "status [number]" as changing status.
Changing status is an action applying to a number.
Carry out changing status:
	say "The status line is now [the number understood] lines deep.";
	Modify the status line to the number understood rows.

To initialize the window variables:
	(- statuswin_size = 3; -).
To modify the/-- status line to (depth - a number) rows:
	(- VM_StatusLineHeight({depth}); -).

[ This DrawStatusLine() comes from the standard rules, but has had the initial call to set the status line depth to 1 removed. ]
Include (-
[ DrawStatusLine width posb;
	@push say__p; @push say__pc;
	BeginActivity(CONSTRUCTING_STATUS_LINE_ACT);
	VM_MoveCursorInStatusLine(1, 1); 
	if (statuswin_current) {
		width = VM_ScreenWidth(); posb = width-15;
		spaces width;
		ClearParagraphing();
		if (ForActivity(CONSTRUCTING_STATUS_LINE_ACT) == false) {
			VM_MoveCursorInStatusLine(1, 2);
			switch(metaclass(left_hand_status_line)) {
				String: print (string) left_hand_status_line;
				Routine: left_hand_status_line();
			}
			VM_MoveCursorInStatusLine(1, posb);
			switch(metaclass(right_hand_status_line)) {
				String: print (string) right_hand_status_line;
				Routine: right_hand_status_line();
			}
		}
		VM_MoveCursorInStatusLine(1, 1); VM_MainWindow();
	}
	ClearParagraphing();
	EndActivity(CONSTRUCTING_STATUS_LINE_ACT);
	@pull say__pc; @pull say__p;
];
-) before "Printing.i6t".

To initialize/initialise the/-- status window with parent (win - a g-window) position (pos - g-window-position):
	(- InitStatusGWindow({win}, {pos} ); -)

Include(-
[ InitStatusGWindow win pos sty;
	if (gg_statuswin == 0) {
		statuswin_cursize = statuswin_size;
		if ( (+ status window background reversed +) ) {
			for (sty=0: sty<style_NUMSTYLES: sty++)
				glk_stylehint_set(wintype_TextGrid, sty, stylehint_ReverseColor, 1);
		}
		gg_statuswin = glk_window_open(win.ref_number, GetPos(pos,win) + winmethod_Fixed, statuswin_cursize, wintype_TextGrid, GG_STATUSWIN_ROCK);
	}
];
-)

To open the/-- status window:
	if the status window is already open, rule fails;
	initialize the status window with parent main-window position g-placeabove.

When play begins:
	Initialize the window variables;
	set the background of the status window to colored;
	set the background color of the status window to g-green;
	set the text color of the status window to g-white;
	open the status window.
